/*
  ----------------------------------------------------------------------
  NOME: Roberto
  CONGNOME: Cavada
  MATRICOLA: xxx
  CODICE CALCOLATORE: 
  ----------------------------------------------------------------------
*/

#include <iostream>
#include <fstream>
#include <cstdlib>

using namespace std;

const int N_PIANI = 2;
const int N_STANZE = 3;
const char* FNAME = "prenotazioni";


/* --------------------------- INIZIO PUNTO 1  ------------------------- */
/*                    Scrivere qui sotto la soluzione                    */
/*    vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv   */

struct Prenotazione {
  char* nome;
  char* cognome;
  int data;
  int giorni;

  Prenotazione () {
    nome = NULL; cognome = NULL;
    data = 0; giorni = 0;
  }

  Prenotazione (char* _nome, char* _cognome, int _data, int _giorni) {
    nome = _nome;
    cognome = _cognome;
    data = _data;
    giorni = _giorni;
  }

};


struct ListaPrenotazioni {
  Prenotazione dato;
  ListaPrenotazioni* next;

  ListaPrenotazioni(const Prenotazione& _dato, 
		    ListaPrenotazioni* _next=NULL) {
    dato = _dato;
    next = _next;
  }
};

    
/*    ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^   */
/* ---------------------------- FINE PUNTO 1  -------------------------- */



/* --------------------------- INIZIO PUNTO 2  ------------------------- */
/*                    Scrivere qui sotto la soluzione                    */
/*    vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv   */
void Prenotazione_stampa(const Prenotazione& p) 
{
  cout << p.nome << " " << p.cognome << ": da " << 
    p.data << " per " << p.giorni;
  if (p.giorni > 1) cout << " giorni";
  else cout << " giorno";
}

void ListaPrenotazioni_stampa(const ListaPrenotazioni* lista)
{
  const ListaPrenotazioni* iter = lista;
  while (iter != NULL) {
    Prenotazione_stampa(iter->dato);
    cout << endl;
    iter = iter->next;
  }
}


/** Dati gli indici di paino e stanza, stampa il nome della stanza */
void stampa_stanza(int p, int s) 
{
  cout << "Stanza " << (p+1) << (s+1);
}

void Albergo_stampa(ListaPrenotazioni* const alb[N_PIANI][N_STANZE])
{
  for (int p=0; p < N_PIANI; ++p) {
    for (int s=0; s < N_STANZE; ++s) {
      stampa_stanza(p,s); cout << ":\n";
      ListaPrenotazioni_stampa(alb[p][s]);
      cout << "-------------------------------------------------\n\n";
    }
  }
}

/*    ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^   */
/* ---------------------------- FINE PUNTO 2 -------------------------- */



/* --------------------------- INIZIO PUNTO 3  ------------------------- */
/*                    Scrivere qui sotto la soluzione                    */
/*    vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv   */

/** restituisce true se p puo' essere inserita tra prev e next */
bool is_pren_ok(const Prenotazione& p, 
		const ListaPrenotazioni* prev, 
		const ListaPrenotazioni* next)
{
  /* va inserito prima, se c'e' abbastanza tempo */
  if ((prev != NULL) && 	
      ((prev->dato.data + prev->dato.giorni) >= p.data)) {
    return false;
  }
  
  if ((next != NULL) && 
      ((p.data + p.giorni) >= next->dato.data)) {
    return false;
  }
  
  return true;
}


/* restituisce true se p1 >= p2 */
bool is_pren_gte(const Prenotazione& p1, const Prenotazione& p2)
{
  return p1.data >= p2.data;
}

bool ListaPrenotazioni_inserisci_prenotazione(ListaPrenotazioni* &lista, 
					      const Prenotazione& p)
{
  ListaPrenotazioni* prev = NULL;
  ListaPrenotazioni* iter = lista;

  while (iter != NULL) {
    if (is_pren_gte(iter->dato, p)) {
      break; /* prova ad inserire tra prev ed iter */
    }

    prev = iter;
    iter = iter->next;
  }

  /* check se inserimento ok */
  if (!is_pren_ok(p, prev, iter)) return false;

  /* inserimento */ 
  ListaPrenotazioni* n = new ListaPrenotazioni(p, iter);
  if (prev != NULL) prev->next = n;
  else lista = n;

  return true; 
}

/*    ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^   */
/* ---------------------------- FINE PUNTO 3 -------------------------- */



/* --------------------------- INIZIO PUNTO 4  ------------------------- */
/*                    Scrivere qui sotto la soluzione                    */
/*    vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv   */
bool Albergo_prenota_stanza(ListaPrenotazioni* alb[N_PIANI][N_STANZE], 
			    const Prenotazione& pren) 
{
  for (int p=0; p < N_PIANI; ++p) {
    for (int s=0; s < N_STANZE; ++s) {
      if (ListaPrenotazioni_inserisci_prenotazione(alb[p][s], pren)) {
	cout << "Fatta prenotazione per ";
	stampa_stanza(p,s); cout << endl;
	return true;
      }
    }
  }

  return false;
}

/*    ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^   */
/* ---------------------------- FINE PUNTO 4 -------------------------- */



/* Inizializza l'albergo inserendo in tutte le stanze una lista di
   prenotazione vuota. */
void Albergo_init(ListaPrenotazioni* alb[N_PIANI][N_STANZE]) 
{
  for (int p=0; p < N_PIANI; ++p) {
    for (int s=0; s < N_STANZE; ++s) {
      alb[p][s] = NULL;
    }
  }
}


/* legge da file una singola prenotazione */
bool leggi_prenotazione(istream& is, Prenotazione &p)
{
  string str;
  is >> str; p.nome = strdup(str.c_str());
  if (is.fail()) return false;

  is >> str; p.cognome = strdup(str.c_str());
  if (is.fail()) return false;

  is >> p.data; 
  if (is.fail()) return false;

  is >> p.giorni;
  if (is.fail()) return false;

  return true;
}

/* carica da un file tutte le prenotazioni nell'albergo */
void Albergo_carica_prenotazioni(ListaPrenotazioni* alb[N_PIANI][N_STANZE])
{
  ifstream ifs(FNAME);
  while (!ifs.eof()) {
    Prenotazione p;
    if (!leggi_prenotazione(ifs, p)) return;
    
    if (! Albergo_prenota_stanza(alb, p)) {
      cout << "La prenotazione:\n   "; 
      Prenotazione_stampa(p);
      cout << endl << "non puo' essere soddisfatta.\n\n";
    }
  }
}


// ----------------------------------------------------------------------
// Main del programma
// ----------------------------------------------------------------------

int main() 
{
  ListaPrenotazioni* albergo[N_PIANI][N_STANZE];
  Albergo_init(albergo);
  Albergo_carica_prenotazioni(albergo);

  Albergo_stampa(albergo);

  return 0;
}
